﻿package
{
	import flash.display.*;
	import flash.events.Event;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.media.Camera;
	import flash.media.Video;
	import flash.net.URLRequest;
	import jp.maaash.ObjectDetection.ObjectDetector;
	import jp.maaash.ObjectDetection.ObjectDetectorOptions;
	import jp.maaash.ObjectDetection.ObjectDetectorEvent;

	public class FaceDetector4 extends MovieClip {
		
		private var detector    :ObjectDetector;
		private var options     :ObjectDetectorOptions;
		public var faceImage   :Sprite;
		private var bmpTarget   :Bitmap;
		
		private var view :Sprite;
		
		private var _cam:Camera;
		private var _video:Video;
		private var _bmp:Bitmap;
		
		public function FaceDetector4() {
			initUI();
			initDetector();
		}
		
		private function initUI():void {
			
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			view = new Sprite;
			addChild(view);
			
			//カメラの設定
			_cam = Camera.getCamera();
			_cam.setMode( 320, 240, 20 );
			_video = new Video( 320 , 240 );
			_video.attachCamera( _cam );
			view.addChild( _video );
			
			//解析用Bitmap
			bmpTarget = new Bitmap( new BitmapData( _video.width, _video.height, false, 0x00FF0000 ) );
			
			_bmp = new Bitmap( new BitmapData( _video.width, _video.height, false, 0x00FF0000 ) );
			view.addChild( _bmp );

			addEventListener( Event.ENTER_FRAME, function():void{ startDetection() } );
			setChildIndex(faceImage, numChildren - 1);
			
		}
		
		private function initDetector():void {
			
			detector = new ObjectDetector;
			detector.options = getDetectorOptions();
			
			detector.addEventListener(ObjectDetectorEvent.DETECTION_COMPLETE, detection_complete );
			
			var events :Array = [ ObjectDetectorEvent.DETECTION_START, ObjectDetectorEvent.HAARCASCADES_LOAD_COMPLETE, ObjectDetectorEvent.HAARCASCADES_LOADING ];
			events.forEach( function(t :String, idx :int, arr :Array ) :void {
				detector.addEventListener( t, function(e :ObjectDetectorEvent) :void {
				});
			});
			
			detector.loadHaarCascades( "face.zip" );
			
		}
		
		/**
		 * 解析完了
		 * @param	e
		 */
		public function detection_complete( e :ObjectDetectorEvent ):void {
			
			if ( e.rects ) {
				
				_bmp.bitmapData.dispose();
				_bmp.bitmapData = new BitmapData( _video.width, _video.height, true, 0x00000000 );
				
				e.rects.forEach( function( r :Rectangle, idx :int, arr :Array ) :void {
					
					faceImage.x += (r.x - faceImage.x ) / 1.5;
					faceImage.y += (r.y - faceImage.y ) / 1.5;
					faceImage.width += (r.width - faceImage.width) / 1.5;
					faceImage.height += (r.height - faceImage.height) / 1.5;
				});
				
			}
			
		}
		
		
		public function startDetection():void {
			bmpTarget.bitmapData.draw( _video );
			detector.detect( bmpTarget );
		}
		
		
		private function getDetectorOptions() :ObjectDetectorOptions {
			options = new ObjectDetectorOptions;
			options.min_size  = 40;
			options.startx    = ObjectDetectorOptions.INVALID_POS;
			options.starty    = ObjectDetectorOptions.INVALID_POS;
			options.endx      = ObjectDetectorOptions.INVALID_POS;
			options.endy      = ObjectDetectorOptions.INVALID_POS;
			return options;
		}
		
	}
}
